



<!DOCTYPE html><html lang=zh-CN><head><meta http-equiv="Content-Type" content="text/html; charset=utf-8" /><meta http-equiv="X-UA-Compatible" content="IE=edge,chrome=1"><meta name="applicable-device" content="pc,mobile"><meta name="renderer" content="webkit"><meta name="viewport" content="width=device-width,initial-scale=1.0,maximum-scale=5,viewport-fit=cover">
<title>HDU 1863 畅通工程（Prim算法求解MST）</title>	
<script src="//n4.ikafan.com/assets/run_prettify.js?ac"></script>
<link rel="stylesheet" href="//n4.ikafan.com/assetsg/style.css">
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/fontello.css?ac"> -->
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/animation.css?ac"> -->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>
<script src="https://n4.ikafan.com/g/show.js"></script>

</head>
<div id="header" class="navbar navbar-default navbar-fixed-top header-01">
	<div class="container">
		<h1 class="logo">
			<a  href="/" title="巴特西"/>
							巴特西
			</a>
		</h1>
				<div role="navigation"  class="site-nav  primary-menu">
			<div class="menu-fix-box">
				 <ul id="menu-navigation" class="menu" >
<li><a href="/">首页</a></li>
<!-- <li><a href="/search/Hadoop/">Hadoop</a></li>
<li><a href="/search/Linux/">Linux</a></li>
<li><a href="/search/jQuery/">jQuery</a></li> -->
<li><a href="/search/Python/">Python</a></li>
<li><a href="/search/Java/">Java</a></li>
<li><a href="/search/PHP/">PHP</a></li>
<li><a href="/search/IOS/">IOS</a></li>
<li><a href="/search/Andorid/">Andorid</a></li>
<li><a href="/search/NodeJS/">NodeJS</a></li>
<li><a href="/search/JavaScript/">JavaScript</a></li>
<li><a href="/search/HTML5/">HTML5</a></li>
				</ul>					 			
			</div>
		</div>
				<!--<div class="right-nav">
				<button class="js-toggle-search"><i class="icon-search"></i></button>
		</div>-->
       
			</div>	
</div>

<div id="page-content">
	<div class="container">
		<div class="row">
			
			<div class="blog-post">
								<!--<div class="posts-top-cjtz clearfix"></div>-->
								<div class="post">
										<div class="post-title">
											<div id="title_top"></div>
<script>insertAdIfNeeded();</script>
						<h1 class="title">HDU 1863 畅通工程（Prim算法求解MST）</h1>
						<div class="post_icon">
							<span class="icon-clock-1"> 2024-02-07 16:48:50 </span>
						</div>
										<div class="post-content">
													<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
											
		<p>题目：</p>
<div>省政府&ldquo;畅通工程&rdquo;的目标是使全省任何两个村庄间都可以实现公路交通（但不一定有直接的公路相连，只要能间接通过公路可达即可）。经过调查评估，得到的统计表中列出了有可能建设公路的若干条道路的成本。现请你编写程序，计算出全省畅通需要的最低成本。&nbsp;</div>
<p>Input测试输入包含若干测试用例。每个测试用例的第1行给出评估的道路条数 N、村庄数目M ( &lt; 100 )；随后的 N&nbsp;<br />行对应村庄间道路的成本，每行给出一对正整数，分别是两个村庄的编号，以及此两村庄间道路的成本（也是正整数）。为简单起见，村庄从1到M编号。当N为0时，全部输入结束，相应的结果不要输出。&nbsp;<br />Output对每个测试用例，在1行里输出全省畅通需要的最低成本。若统计数据不足以保证畅通，则输出&ldquo;?&rdquo;。&nbsp;<br />Sample Input</p>
<pre class="prettyprint linenums">3 3<br />
1 2 1<br />
1 3 2<br />
2 3 4<br />
1 3<br />
2 3 2<br />
0 100</pre>
<p>Sample Output</p>
<pre class="prettyprint linenums">3<br />
?<br />题意描述：<br />输入道路条数和城市数目<br />计算并输出使任意两个村庄直接或者间接连通的最短距离<br />解题思路：</pre>
<pre class="prettyprint linenums">属于最小生成树问题，按照数据格式，使用Kruskal算法即可。<br />代码实现：</pre>
<div>
<pre class="prettyprint linenums"> #include&lt;stdio.h&gt;<br />
 #include&lt;string.h&gt;<br />
 int e[][],book[],dis[];<br />
 const int inf=;<br />
 int main()<br />
 {<br />
     int n,m,min,t1,t2,t3,i,j,c,sum,k;<br />
     while(scanf("%d%d",&amp;m,&amp;n), m != )//m为道路条数，n为村庄个数<br />
     {<br />
         memset(e,,sizeof(e));<br />
         for(i=;i&lt;=n;i++)//初始化邻接矩阵<br />
         {<br />
             for(j=;j&lt;=n;j++){<br />
                 if(i==j)<br />
                 e[i][j]=;<br />
                 else<br />
                 e[i][j]=inf;<br />
             }<br />
         }<br />
         for(i=;i&lt;=m;i++)<br />
         {<br />
             scanf("%d%d%d",&amp;t1,&amp;t2,&amp;t3);<br />
             e[t1][t2]=t3;<br />
             e[t2][t1]=t3;<br />
         }<br />
         for(i=;i&lt;=n;i++)//初始化dis，存储距离生成树(仅有1顶点）到每个非树顶点的距离<br />
             dis[i]=e[][i];<br />
         memset(book,,sizeof(book));<br />
         book[]=;<br />
         c=;<br />
         sum=;//sum初始化，当只有一个正确样例时注意多复制一下 

         while(c &lt; n)//直到找到n-1条边<br />
         {<br />
             min=inf;<br />
             for(j=,i=;i&lt;=n;i++)<br />
             {//遍历每个定点，找到某个顶点没有被用过而且距离生成树又最近<br />
                 if(book[i]== &amp;&amp; dis[i] &lt; min)<br />
                 {<br />
                     min=dis[i];<br />
                     j=i;<br />
                 }<br />
             }<br />
             book[j]=;//标记使用并计数，将其累加到sum上<br />
             c++;<br />
             sum += dis[j];

             for(k=;k&lt;=n;k++)<br />
             {//最后遍历所有边，以j为中间点更新dis数组中生成树到每一个非树顶点的距离<br />
                 if(book[k]== &amp;&amp; dis[k] &gt; e[j][k])<br />
                     dis[k]=e[j][k];<br />
             }<br />
         }

         for(i=;i&lt;=n;i++){<br />
             if(!book[i])<br />
                 break;<br />
         }<br />
         if(i == n+)<br />
         printf("%d\n",sum);<br />
         else<br />
         printf("?\n");<br />
     }<br />
     return ;<br />
 }</pre>
</div>
<p>易错分析：</p>
<p>1、注意数据输入，结点数在前还是边数在前</p>
<p>2、当只有一个样例时，多出几组测试样例，想几个样例的时间跟罚时20分钟比起来要少的多，另外不影响情绪</p>												<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
																
<h2>最新文章</h2>	
<ol>
						<li><a href="https://www.batexi.com/a/0qwjmr38.html">php sprintf 函数的用法</a>
		</li>
						<li><a href="https://www.batexi.com/a/g8e5wrz8.html">ps commad</a>
		</li>
						<li><a href="https://www.batexi.com/a/4qnynvj8.html">codeforces 732E（贪心）</a>
		</li>
						<li><a href="https://www.batexi.com/a/390k4noq.html">基于WinCE的JSON 类库 源码</a>
		</li>
						<li><a href="https://www.batexi.com/a/1q21rjo8.html">&lbrack;问题2014S12&rsqb;  解答</a>
		</li>
						<li><a href="https://www.batexi.com/a/39rxrye9.html">url rewrite</a>
		</li>
						<li><a href="https://www.batexi.com/a/9pjnwrk9.html">。。。Spring框架总结（一）。。。</a>
		</li>
						<li><a href="https://www.batexi.com/a/8k10dlj9.html">PHP使用PHPExcel删除Excel单元格指定列的方法是怎样</a>
		</li>
						<li><a href="https://www.batexi.com/a/q2w320xq.html">MFC学习20160718（GetModuleFileName&amp;amp&semi;&amp;amp&semi;GetAppDataPath）</a>
		</li>
						<li><a href="https://www.batexi.com/a/qyd67lgq.html">实现c&plus;&plus;的string的split功能</a>
		</li>
						<li><a href="https://www.batexi.com/a/96onyn49.html">关于用jQuery知识来实现优酷首页轮播图！</a>
		</li>
						<li><a href="https://www.batexi.com/a/q1z31o59.html">CSS3 Flexbox布局那些事</a>
		</li>
						<li><a href="https://www.batexi.com/a/qydmmd2q.html">C语言--流程控制</a>
		</li>
						<li><a href="https://www.batexi.com/a/qljxn5k9.html">NYOJ15-括号匹配&lpar;二&rpar;-区间DP</a>
		</li>
						<li><a href="https://www.batexi.com/a/qv1mx01q.html">SSM-Spring-18：Spring中aspectJ的XML版</a>
		</li>
						<li><a href="https://www.batexi.com/a/q4zoej09.html">FTP方式部署Azure Web App</a>
		</li>
						<li><a href="https://www.batexi.com/a/8kpxr569.html">对接携程供应商php加密解密类</a>
		</li>
						<li><a href="https://www.batexi.com/a/9r5n7g4q.html">C&num;发布和调试WebService</a>
		</li>
						<li><a href="https://www.batexi.com/a/9gj3dme9.html">laravel中如何在模型中自关联？</a>
		</li>
						<li><a href="https://www.batexi.com/a/8zy6dj19.html">MySQL 大数据备份方案之Percona XtraBackup</a>
		</li>
		</ol>
	

<h2>热门文章</h2>	
<ol>
									<li><a href="https://www.batexi.com/a/8zk3j7d8.html">web  api 多版本控制重要的两个类</a>
			</li>
						<li><a href="https://www.batexi.com/a/8emw3ve9.html">&lbrack;Xamarin&rsqb;我的Xamarin填坑之旅（二）</a>
			</li>
						<li><a href="https://www.batexi.com/a/93p7gww8.html">第二章 ConcurrentHashMap源码解析</a>
			</li>
						<li><a href="https://www.batexi.com/a/9gpgry09.html">Day 34   面试题</a>
			</li>
						<li><a href="https://www.batexi.com/a/9gpgxml9.html">Java基础学习篇---------String、集合的学习</a>
			</li>
						<li><a href="https://www.batexi.com/a/8mjkx428.html">《Python黑帽子：黑客与渗透测试编程之道》 Scapy：网络的掌控者</a>
			</li>
						<li><a href="https://www.batexi.com/a/953dypz8.html">BS4爬取物价局房产备案价以及dataframe的操作来获取房价的信息分析</a>
			</li>
						<li><a href="https://www.batexi.com/a/ql1v7pe9.html">poj1220------高精度进制转换模板</a>
			</li>
						<li><a href="https://www.batexi.com/a/ql1v7019.html">FunDA（15）－ 示范：任务并行运算 - user task parallel execution</a>
			</li>
						<li><a href="https://www.batexi.com/a/9rn7mleq.html">mybatis源码追踪2&mdash;&mdash;将结果集映射为map</a>
			</li>
			</ol>			
							
					</div>

					
<div class="next-prev-posts clearfix">
</div>
						 
				</div>
				
	<div class="clear"></div>

			</div>	
			

		</div>
</div>
</div>


<div class="clearfix"></div>
<div id="footer" class="two-s-footer">
	<div class="footer-box">
		<div class="container">
			<div class="row" style="padding-left: 15px;padding-right: 15px;">
			<div class="nav-footer">
				<a href="/">Home</a>
				</div>
				<div class="copyright-footer">
					<p>Powered By WordPress</p>
				</div>
							</div>
		</div>
	</div>
</div>
<div style="display:none">

</div>
<script src="//n4.ikafan.com/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
 </script>
</body>
</html>
